///////////////////////////////////////////////////////////////////////
//
// File: test.cpp
// Author: Kelvin Sung
// Date: April, 2003
//
//
//
//   1. Starts 5 worker threads (id = 1-5), each with a very different working time
//			ranging from 1 - 10 seconds
//
//   2. Poll the user to enter an id, send a job to the "id" worker
// 
//   3. counts how many jobs each worker has been assigned.
//
// 
//
//
//		TsyncObject: makes sure, each id user enters will only result in
//				one job being performed by the id-worker.
//
// 
#include <iostream.h>

#include "TworkerThread.h"

#include <Windows.h>


#define kNumWorkers 5

int main() {

	TsyncObject &sync = TworkerThread::GetSyncObject();


	int sleepTimes[kNumWorkers] = {1, 2, 3, 5, 10};
	int totalNumJobs[kNumWorkers] = {0, 0, 0, 0, 0};


	cout << "Sync Tests Workers=[1-5] Times=[1, 2, 3, 5, 10]" << endl;

	//
	// Start all the worker threads ...
	//
	for (int i=0; i<kNumWorkers; i++) {
		TworkerThread *wk = new TworkerThread("MyWorkers", i+1, sleepTimes[i]);
		wk->StartThread();
	}


	int workerID = 0;
	while (workerID >= 0) {

		cout << "Worker ID:  [1-5]   -1 to quit]? ";
		cin >> workerID;

		if ( (workerID > 0) && (workerID <= kNumWorkers) ) {
			totalNumJobs[workerID-1]++;	
			sync.SetCommand(workerID);
		}
	}

	sync.SetTerminateAll();

	cerr << "TotalNumJobs= " 
		 << totalNumJobs[0] << " "
		 << totalNumJobs[1] << " "
		 << totalNumJobs[2] << " "
		 << totalNumJobs[3] << " "
		 << totalNumJobs[4] << " "
		 << endl;

	Sleep((long)20000);
		// wait 20 seconds, making sure all worker threads are done before
		// quit.

	return 0;
}
